import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

public class DecoratedBall extends Ball
{
   private Ball workerBall;

   public DecoratedBall( Ball aBall )
   {
      super();
      workerBall = aBall;
   }

   protected Ball worker()
   {
      return workerBall;
   }

   // *** MESSAGES DELEGATED TO THE INSTANCE VARIABLE

    public void move()
    {
        workerBall.move();
    }

    public void paint( Graphics g )
    {
        workerBall.paint( g );
    }

    protected void adjustSpeedBy( double ddx, double ddy )
    {
        workerBall.adjustSpeedBy( ddx, ddy );
    }

    protected void adjustSpeedBy( double factor )
    {
        workerBall.adjustSpeedBy( factor );
    }

    protected void reverseDeltaX()
    {
        workerBall.reverseDeltaX();
    }

    protected void reverseDeltaY()
    {
        workerBall.reverseDeltaY();
    }
    
    protected void moveBy( int deltaX, int deltaY )
    {
        workerBall.moveBy( deltaX, deltaY );
    }

    protected void growBy( int changeInRadius )
    {
        workerBall.growBy( changeInRadius );
    }

    protected int x()
    {
        return workerBall.x();
    }

    protected int y()
    {
        return workerBall.y();
    }

    protected Color color()
    {
        return workerBall.color();
    }

    protected void setColor( Color c )
    {
        workerBall.setColor( c );
    }
}
